From d932041745a3cd9fd314c4bc266ba1cae2532bcf Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 04 2020 07:31:56 +0000
Subject: [PATCH 525/2232] Catch function name collisions


---

diff --git a/syntax/types.rs b/syntax/types.rs
index 11db1b7..e09b5cf 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -1,6 +1,6 @@
 use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::set::OrderedSet as Set;
-use crate::syntax::{Api, Derive, Enum, ExternType, Struct, Type};
+use crate::syntax::{Api, Derive, Enum, ExternFn, ExternType, Struct, Type};
 use proc_macro2::Ident;
 use quote::quote;
 use std::collections::{BTreeMap as Map, HashSet as UnorderedSet};
@@ -44,6 +44,7 @@ impl<'a> Types<'a> {
         }
 
         let mut type_names = UnorderedSet::new();
+        let mut function_names = UnorderedSet::new();
         for api in apis {
             match api {
                 Api::Include(_) => {}
@@ -75,6 +76,9 @@ impl<'a> Types<'a> {
                     rust.insert(&ety.ident);
                 }
                 Api::CxxFunction(efn) | Api::RustFunction(efn) => {
+                    if !function_names.insert((&efn.receiver, &efn.ident)) {
+                        return Err(duplicate_function(efn));
+                    }
                     for arg in &efn.args {
                         visit(&mut all, &arg.ty);
                     }
@@ -146,3 +150,7 @@ fn duplicate_type(ety: &ExternType) -> Error {
     let range = quote!(#type_token #ident);
     Error::new_spanned(range, "duplicate type")
 }
+
+fn duplicate_function(efn: &ExternFn) -> Error {
+    Error::new_spanned(efn, "duplicate function")
+}

